/******************************************************************/
/*                                                                */
/*                       CalcInfo.c                               */
/*       Taiga Yonekura 2000 All Rights Reserved                  */
/******************************************************************/
/* Rev  :  DATE    : contents                      :name          */
/*------:----------:-------------------------------:--------------*/
/*      :2000/10/24: Ԋ\tH[    :Taiga Yonkura */
/* 1.1  :2001/03/03: n[h{^ǉ          :              */
/*      :          : j̃vbV{^ǉ      :              */
/* 1.2  :2001/03/17: Ȗڏڍ׉ʕύX              :              */
/*      :          : ̉ʂCtH[ɕύX:              */
/* 1.3  :2001/04/21: n[h{^jړǉ  :              */
/* 1.3.1:2001/05/08: foCXˑΉʃNA    :              */
/******************************************************************/


#include <PalmOS.h>

#include "timeRsc.h"
#include "Comlib.h"
#include "timeTable.h"

#define KEYWAITDAYINFO 30	//*1.3*

//static UInt16 CalcIndex;	//jp
//static UInt16 CalcIndexTop;

static Char dayType;		//j
static UInt16 time;
static Boolean scrollableUp;
static Boolean scrollableDown;

static void drawDayStringDayInfo();
static void setscrollable();

//*1.3*
//pushButton̏
//
void setPushButtonDayInfo(UInt16 day)
{
	UInt16 i;
	
	for(i = 0;i < 7;i++){
		if(i == day){
			CtlSetValue (GetObjectPtr (DAYPUSHBTN1 + i),true);
		} else {
			CtlSetValue (GetObjectPtr (DAYPUSHBTN1 + i),false);
		}
	}
}
//
//CtH[痈Ƃ̕\ǰ
//
void initDayInfo(UInt16 ctrID)
{
	UInt16 idx;
	
	idx = getleftTopCalcIndex();
	
	switch(ctrID){
		
	case DAYPUSHBTN2:
	break;
	
	case DAYPUSHBTN3:
		idx += 1;
	break;
	
	case DAYPUSHBTN4:
		idx += 2;
	break;
	
	case DAYPUSHBTN5:
		idx += 3;
	break;
	
	}
	
	dayType = getDayType(idx);
	time = 1;
	setscrollable();
}
//*1.2
// CtH[I[v̗\\
//
void firstOpenDayInfo()
{
	dayType = WhatDay();
	if(dayType == 0) dayType = 6; else dayType--;
	time = 1;
	setscrollable();
}
//
//ʂ̕`
//
void drawDayInfoFrm()
{
	FormPtr frm;
	Curc *pcurc;
	Char str[10];
	UInt16 topTime = time;
	
	UInt16 upIndex;
	UInt16 downIndex;
	
	frm = FrmGetActiveForm();
	FrmDrawForm (frm);
	
	drawDayStringDayInfo();
	
	pcurc = getCurcData(dayType,topTime);
	StrIToA(str,topTime);
	appendChar(str,":");
	WinDrawChars(str,StrLen(str),10,30);
	WinDrawChars("@@@@@@@@@@@@@@",StrLen("@@@@@@@@@@@@@@"),45,30);/*1.3.1*/
	WinDrawChars("@@@@@@@@@@@@@@",StrLen("@@@@@@@@@@@@@@"),45,40);/*1.3.1*/
	WinDrawChars(pcurc->title,StrLen(pcurc->title),45,30);
	WinDrawChars(pcurc->room,StrLen(pcurc->room),45,40);
	
	topTime++;
	pcurc = getCurcData(dayType,topTime);
	StrIToA(str,topTime);
	appendChar(str,":");
	WinDrawChars(str,StrLen(str),10,50);
	WinDrawChars("@@@@@@@@@@@@@@",StrLen("@@@@@@@@@@@@@@"),45,50);/*1.3.1*/
	WinDrawChars("@@@@@@@@@@@@@@",StrLen("@@@@@@@@@@@@@@"),45,60);/*1.3.1*/
	WinDrawChars(pcurc->title,StrLen(pcurc->title),45,50);
	WinDrawChars(pcurc->room,StrLen(pcurc->room),45,60);

	topTime++;
	pcurc = getCurcData(dayType,topTime);
	StrIToA(str,topTime);
	appendChar(str,":");
	WinDrawChars(str,StrLen(str),10,70);
	WinDrawChars("@@@@@@@@@@@@@@",StrLen("@@@@@@@@@@@@@@"),45,70);/*1.3.1*/
	WinDrawChars("@@@@@@@@@@@@@@",StrLen("@@@@@@@@@@@@@@"),45,80);/*1.3.1*/
	WinDrawChars(pcurc->title,StrLen(pcurc->title),45,70);
	WinDrawChars(pcurc->room,StrLen(pcurc->room),45,80);

	topTime++;
	pcurc = getCurcData(dayType,topTime);
	StrIToA(str,topTime);
	appendChar(str,":");
	WinDrawChars(str,StrLen(str),10,90);
	WinDrawChars("@@@@@@@@@@@@@@",StrLen("@@@@@@@@@@@@@@"),45,90);/*1.3.1*/
	WinDrawChars("@@@@@@@@@@@@@@",StrLen("@@@@@@@@@@@@@@"),45,100);/*1.3.1*/
	WinDrawChars(pcurc->title,StrLen(pcurc->title),45,90);
	WinDrawChars(pcurc->room,StrLen(pcurc->room),45,100);
	
	topTime++;
	pcurc = getCurcData(dayType,topTime);
	StrIToA(str,topTime);
	appendChar(str,":");
	WinDrawChars(str,StrLen(str),10,110);
	WinDrawChars("@@@@@@@@@@@@@@",StrLen("@@@@@@@@@@@@@@"),45,110);/*1.3.1*/
	WinDrawChars("@@@@@@@@@@@@@@",StrLen("@@@@@@@@@@@@@@"),45,120);/*1.3.1*/
	WinDrawChars(pcurc->title,StrLen(pcurc->title),45,110);
	WinDrawChars(pcurc->room,StrLen(pcurc->room),45,120);
	
	// XN[{^̐ݒ
	upIndex = FrmGetObjectIndex (frm, RepBtnUP);
	downIndex = FrmGetObjectIndex (frm, RepBtnDown);
	setscrollable();
	FrmUpdateScrollers (frm, upIndex, downIndex, scrollableUp, scrollableDown);
	
	setPushButtonDayInfo((Char)dayType);//*1.3*
}
//*1.1*
//j̃vbV{^ꂽƂ̏
//
Boolean selectDayInfo(UInt16 ctrID)
{
	Boolean ret = true;
	
	switch(ctrID){
		
	case DAYPUSHBTN1:
		dayType = MONDAY;
	break;
	
	case DAYPUSHBTN2:
		dayType = TUEDAY;
	break;
	
	case DAYPUSHBTN3:
		dayType = WESDAY;
	break;
	
	case DAYPUSHBTN4:
		dayType = THUDAY;
	break;
	
	case DAYPUSHBTN5:
		dayType = FRIDAY;
	break;
	
	case DAYPUSHBTN6:
		dayType = SATDAY;
	break;
	
	case DAYPUSHBTN7:
		dayType = SUNDAY;
	break;
	
	default:
		ret = false;
	}
	
	if(ret == true){
		drawDayInfoFrm();
	}
	
	return ret;
}

//
//
//
void pushUpBtnDayInfo()
{
	if(time > 1){
		time--;
	}
	
	drawDayInfoFrm();
}
//
//
//
void pushDownBtnDayInfo()
{
	if(time < 4){
		time++;
	}

	drawDayInfoFrm();
}
//*1.2* j̕ZbgW[
//
//
static void drawDayStringDayInfo()
{
	Char str[30];
	
	str[0] = '\0';
	
	getDayString(dayType,str); /*1.2*/

	appendChar(str,"j̃XPW[");
	
	WinDrawChars(str,StrLen(str),40,15);
}
//
//
//
static void setscrollable()
{
	if(time == 1){
		scrollableUp = false;
	} else {
		scrollableUp = true;
	}
	
	if(time == 4){
		scrollableDown = false;
	} else {
		scrollableDown = true;
	}
}
//*1.3*
//n[hEGAL[ꂽƂijړj
//
static void pushKeyLeft(void)
{
	if(dayType > MONDAY){
		sleepWait(KEYWAITDAYINFO);
		dayType--;
	}
	
	drawDayInfoFrm();
}
//*1.3*
//n[hEGAL[ꂽƂijړj
//
static void pushKeyRight(void)
{
	if(dayType < SUNDAY){
		sleepWait(KEYWAITDAYINFO);
		dayType++;
	}
	
	drawDayInfoFrm();
}
//*1.1*
// n[h{^ǉ
//
void keyDownDayInfoFrm()
{
	UInt32 keyType;
	
	keyType = KeyCurrentState();
	
	if (keyType & 0x02) {       //Up
		sleepWait(KEYWAITDAYINFO);//*1.3*
		pushUpBtnDayInfo();
	} else if (keyType & 0x04) {//Down
		sleepWait(KEYWAITDAYINFO);//*1.3*
		pushDownBtnDayInfo();
	} else if (keyType & 0x10) {//left *1.3*
		pushKeyLeft();
	} else if (keyType & 0x20) {//right *1.3*
		pushKeyRight();
	}
}

